//+------------------------------------------------------------------+
//|                                                    Spdmtr_v4.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_width2 2
extern int MA_Period=8;
extern int MaxValue=5;
//---- buffers
double SpeedMeter[];
double SMA[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,SpeedMeter);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,SMA);
   IndicatorShortName("SpeedMeter("+MA_Period+")");
   SetIndexLabel(0,"SpeedMeter");
   SetIndexLabel(1,"SMA"+MA_Period);
   return(0);
  }
//+------------------------------------------------------------------+
//| Average True Range                                               |
//+------------------------------------------------------------------+
int start()
  {
   int i,j,counted_bars=IndicatorCounted();
   double sum;
//----
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
   i=Bars-counted_bars-1;
   while(i>=0)
     {
      if(i==Bars-2){
         SpeedMeter[i]=0;
      }
      if(Close[i]>Open[i]){
         SpeedMeter[i]=SpeedMeter[i+1]+1;
      }else if(Close[i]<Open[i]){
         SpeedMeter[i]=SpeedMeter[i+1]-1;
      }else{
         SpeedMeter[i]=SpeedMeter[i+1]+0;
      }
      if(SpeedMeter[i]>MaxValue){
         SpeedMeter[i]=MaxValue;
      }
      if(SpeedMeter[i]<-MaxValue){
         SpeedMeter[i]=-MaxValue;
      }
      if(i<=Bars-1-MA_Period){
         sum=0;
         for(j=0;j<MA_Period;j++){
            sum+=SpeedMeter[i+j];
         }
         SMA[i]=sum/MA_Period;
      }
      i--;
    }
//----
   return(0);
  }
//+------------------------------------------------------------------+
